# Jaida. Styles for 2D

from hep.aida import *
from java.util import Random
from jhplot import *

factory = IAnalysisFactory.create();
tree = factory.createTreeFactory().create();
hf = factory.createHistogramFactory(tree);

h2 = hf.createHistogram2D("Histogram 2D",40,-3,3,40,-3,3)
c2 = hf.createCloud2D("Cloud 2D")

r = Random();
for i in range(10000) :
	h2.fill(r.nextGaussian(),r.nextGaussian());
	c2.fill(r.nextGaussian(),r.nextGaussian());


c1=HPlotter("Histogram",700,700,2,2)
c1.visible()

c1.cd(1,1)
c1.setGTitle("Histogram 2D")
style=c1.getRegionStyle()
style.setParameter("backgroundColor","yellow");
style.setParameter("foregroundColor","green");
style.setParameter("hist2DStyle","ellipse");
style.dataStyle().markerStyle().setColor("blue");
c1.draw(h2,style);

c1.cd(2,1)
c1.setGTitle("Color Map")
style=c1.getRegionStyle()
style.setParameter("showStatisticsBox","false");
style.setParameter("hist2DStyle","colorMap");
style.dataStyle().fillStyle().setParameter("colorMapScheme","rainbow");
c1.draw(h2,style)


c1.cd(1,2)
c1.setTitle("Points");
style=c1.getRegionStyle()
style.dataStyle().markerStyle().setColor("red");
style.dataStyle().markerStyle().setShape("1");
style.dataStyle().markerStyle().setParameter("size","7");
c1.draw(c2,style)

c1.cd(2,2)
c1.setGTitle("Color Map")
style=c1.getRegionStyle()
style.setParameter("showAsScatterPlot","false");
c1.draw(c2,style)
